"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAppHook = void 0;
const react_1 = require("react");
const connect_core_1 = require("@1hive/connect-core");
const use_connect_1 = require("./use-connect");
const utils_1 = require("./utils");
function createAppHook(appConnect, connector) {
    connect_core_1.warn('createAppHook is going to be deprecated in the next version. ' +
        'Please use useConnect() and the appConnectors prop on <Connect />.');
    return function useAppData(app, callback, dependencies) {
        // Store the callback as a ref so consumers can declare it inline.
        const callbackRef = react_1.useRef((app) => app);
        react_1.useEffect(() => {
            callbackRef.current = callback || ((app) => app);
        }, [callback]);
        const [[connectedApp, appError], setApp] = react_1.useState([null, null]);
        const appHashRef = react_1.useRef('');
        react_1.useEffect(() => {
            const appHash = utils_1.hash(app);
            // Only update the app when it has changed.
            if (appHash === appHashRef.current) {
                return;
            }
            appHashRef.current = appHash;
            // Don’t try to connect if the app doesn’t exist yet
            if (!app) {
                return;
            }
            let cancelled = false;
            appConnect(app, connector)
                .then((connectedApp) => {
                if (!cancelled) {
                    setApp([connectedApp, null]);
                }
            })
                .catch((err) => {
                if (!cancelled) {
                    setApp([null, err]);
                }
            });
            return () => {
                cancelled = true;
            };
        }, [app]);
        return use_connect_1.useConnect(() => {
            if (appError) {
                throw appError;
            }
            return connectedApp ? callbackRef.current(connectedApp) : undefined;
        }, [...(dependencies || []), connectedApp, appError]);
    };
}
exports.createAppHook = createAppHook;
//# sourceMappingURL=create-app-hook.js.map