import { ReactNode } from 'react';
import type { ConnectOptions, ConnectorDeclaration, Organization } from '@1hive/connect';
import { SubscriptionResult, SubscriptionStart } from '@1hive/connect-types';
export declare type ConnectProps = {
    children: ReactNode;
    connector: ConnectorDeclaration;
    location: string;
    options?: ConnectOptions;
};
export declare type LoadingStatus = {
    error: Error | null;
    loading: boolean;
    retry: () => void;
};
export declare type ContextValue = {
    org: Organization | null;
    orgStatus: LoadingStatus;
};
export declare type UseConnectResult<T> = [T | undefined, LoadingStatus];
export declare type UseConnectCallback<T> = (organization: Organization) => T | Promise<T> | SubscriptionResult<T> | undefined;
export declare function isSubscriptionStart<T>(value: unknown): value is SubscriptionStart<T>;
//# sourceMappingURL=types.d.ts.map