import { createContext, useContext } from 'react';
export const ConnectContext = createContext(null);
export function useConnectContext() {
    const contextValue = useContext(ConnectContext);
    if (contextValue === null) {
        throw new Error('The <Connect /> component need to be declared in order to use the provided hooks.');
    }
    return contextValue;
}
//# sourceMappingURL=connect-context.js.map